//============================================================================
// Name        : copyexample.cpp
// Author      : 
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <ostream>
#include <iostream>
#include <fstream>
using namespace std;

class MyClass {
	int a;
public:
	MyClass(int i) : a(i) {
		cout << "Constructor" << endl;
	}
	MyClass(const MyClass &r) {
		cout << "Copy constructor" << endl;
		a = r.a;
		//a = 0;
	}
	void fun(int y) { a = y; }
	int get() const { return a; }
};

ostream& operator<<(ostream &o, const MyClass &obj)
{
	o << obj.get();
	return o;
}

void g(MyClass c)
{
	cout << c << endl;

	c.fun(10);
	cout << "c has been updated to 10" << endl;
	cout << c << endl;
}

int main() {
	ofstream myfile("textfile.txt");

	cout << "!!!Hello World!!!" << endl;

	MyClass obj(2);

	myfile << obj << endl;

	g(obj);

	cout << "obj.get() = " << obj.get() << endl;

	return 0;
}
